@echo off
if "%NEURO%" == "" goto Usage1

if exist errors.log del errors.log

if "%1" == "DEBUG" goto builddebug
if "%1" == "NDEBUG" goto buildrelease
if "%1" == "" goto buildrelease
goto Usage2


:builddebug
del *.elf > nul
echo ----------- Build NeuroC++ runtime libraries (debug) -------------
echo ----------- Build NeuroC++ runtime libraries (debug) ------------- > libcd.log
asm -mrtmacro.mlb rtmacro.asm
asm -mmacros640x.mlb macros640x.asm
asm -mdwarf_ct.mlb dwarf_ct.asm
for %%i in (*.asm) do nmcc %%i -Snolink >> libcd.log
for %%i in (*.c) do nmcc %%i %2 -g -Snolink -I. >> libcd.log
for %%i in (*.cpp) do nmcc %%i %2 -g -Snolink -I. >> libcd.log
libr -c libcd.lib *.elf >> libcd.log

goto test


:buildrelease
del *.elf > nul
echo ----------- Build NeuroC++ runtime libraries (release) -----------
echo ----------- Build NeuroC++ runtime libraries (release) ----------- > libc.log
asm -mrtmacro.mlb rtmacro.asm
asm -mmacros640x.mlb macros640x.asm
asm -mdwarf_ct.mlb dwarf_ct.asm
for %%i in (*.asm) do nmcc %%i -Snolink -I. >> libc.log
for %%i in (*.c) do nmcc %%i %2 -Snolink -I. >> libc.log
for %%i in (*.cpp) do nmcc %%i %2 -Snolink >> libc.log
libr -c libc.lib *.elf >> libc.log

goto test


rem Unused commands
:example
for %%i in (*.c) do nmcc %%i -Snolink >> libc.log
for %%i in (*.asm) do nmcc %%i -Snolink >> libc.log
libr -c libc.lib *.elf >> libc.log
:endexample


:test
if exist errors.log goto ErrorBuild
echo -------------------------- Build done ----------------------------
goto exit

:ErrorBuild
echo ***
echo *** BUILD ABORTED -- ErrorLevel is non-zero !
echo ***
goto exit


:Usage1
echo The environment variable NEURO must be set to point
echo to the root of your NM SDK installation.
goto exit

:Usage2
echo "makelib" builds the release version of runtime library
echo "makelib DEBUG" builds the debug version of runtime library
echo you can set addition option to compiler by second parameter,
echo for example, "makelib NDEBUG -O1" perform release building
echo with new compiler with medium optimization
goto exit

:exit
