//////////////////////////////////////////////////////////////////////////
//                                                                      //
//               NeuroMatrix(r) C runtime library                       //
//                                                                      //
//  strcmp.c                                                            //
//                                                                      //
// Copyright (c) 1997-2008 RC Module                                    //
//  If this code works, it was written by Alex Ruzavin                  //
//  If not, I don't know who wrote it.                                  //
//                                                                      //
// $Revision:: 2     $      $Date:: 2/01/08 1:56p    $                  //
//                                                                      //
//////////////////////////////////////////////////////////////////////////

#include <string.h>

#ifdef __cplusplus
extern "C"
#endif  // __cplusplus

#if !defined(__NM6403__) && !defined(__NM6405__)

int strcmp ( const char *p1, const char *p2)
{
  int *s1 = (int *) p1;
  int *s2 = (int *) p2;
  int c1, c2;

  do
    {
      c1 = *s1++;
      c2 = *s2++;
      if (c1 == 0)
	return c1 - c2;
    }
  while (c1 == c2);

  return c1 - c2;
}

#else		//	    ..

int strcmp ( const char *, const char *)
{
	__asm{
		ar7 += 4;
		push ar0,gr0;
		push ar1,gr1;
		push ar3,gr3;
		push ar4,gr4;
		push ar5,gr5;
									//<12,1>

	//13:   #endif
	//14:   int strcmp ( const char *p1, const char *p2)
	//15:   {
	//16:     int *s1 = (int *) p1;

		ar0 = ar6 set;                                  //<16,21>

	//17:     int *s2 = (int *) p2;

		ar3 = ar6 set;                                  //<17,21>
		ar4 = [ar0+=-5];                                  //<16,21>

	//18:     int c1, c2;
	//19:
	//20:     do
//    
		//	 :  ,       ,
		//	     ,     
		//	   

		//	 :         
		//	,    __  .

		ar0 = [ar3+=-6] with gr1 = false;                                  //<20,3>
	<L2>

	//21:       {
	//22:         c1 = *s1++;

		gr0 = [ar4++];                                  //<22,15>
		gr5 = [ar0++];                                  //<24,14>

		gr4 = [ar4++] with gr0;                                  //<22,15>
		gr1 = [ar0++];                                  //<24,14>
<L2_1>
		if =0 delayed goto L4_1 with gr4;                                  //<24,14>
		gr0 = [ar4++] with gr3 = gr0 - gr5 noflags;                                  //<22,15>
		gr5 = [ar0++] with gr7 = gr4 - gr1 noflags;                                  //<24,14>

		if =0 delayed goto L3_1 with gr7 or gr3;                                  //<24,14>
		gr4 = [ar4++];                                  //<22,15>
		gr1 = [ar0++];

		if =0 goto L2_1 with gr0;

	<L3_1>
		gr3;                                  //<24,14>
		if =0 goto L4;                                  //<24,14>
	<L4_1>
		gr7 = gr3;
	<L4>
		pop ar5,gr5;
		pop ar4,gr4;
		pop ar3,gr3;
		pop ar1,gr1;
		pop ar0,gr0;
		ar7 = ar6;
		pop ar6,gr6;
	return;                                  //<29,3>
	}
  return 0;
}

#endif  // !defined(__NM6403__) && !defined(__NM6405__)
