//////////////////////////////////////////////////////////////////////////////
//                                                                          //
// main.cpp -                                                               //
//                                                                          //
// The neural net implementation test (main routine)                        //
//                                                                          //
// Copyright (c) 1999 RC Module Inc.                                        //
//                                                                          //
// $Revision:: 3     $      $Date:: 29.08.12 16:01   $                      //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////


#include "layers.h"
#include <stdlib.h>
#include <time.h>


    // number of neurons in the hidden layer
static const size_t nHidden = 512;


    // Arrays defined in data.asm
extern "C" long input[16];               			// net inputs (12 values)
extern "C" long hidden[1024];              			// first layer outputs (1024 values)
extern "C" long output[12];              			// second layer outputs (12 values)
extern "C" unsigned long weights1[12 / 4 * 1024];   // first layer weights
extern "C" unsigned long weights2[1024 / 4 * 12];   // second layer weights

inline int InitVal ()
{
    return rand() - ( RAND_MAX >> 1 );
}


void InitWeights ( unsigned long *weights, int nInputs, int nNeurons )
{
    int *pw = reinterpret_cast< int* >(weights);
    for ( int i = 0; i < nNeurons; i++ ) {
        for ( int j = 0; j < nInputs; j += 2 ) {
            *pw = ( ( i - j ) & 0xffff ) + ( ( j - i ) << 16 );
                // ( InitVal() & 0xffff ) | ( InitVal() << 16 );
            pw++;
        }
    }
}


void Init ()
{
    int i;

    for ( i = 0; i < 12; i++ ) {
        input[i] = InitVal();
    }
    for ( ; i < 16; i++ ) {
        input[i] = 0;
    }

    InitWeights( weights1, 12, nHidden );
    InitWeights( weights2, nHidden, 12 );
}


int main ()
{

        // initialize data

    Init();

        // get the starting clock value

    clock_t t1 = clock();

        // evaluate the sums of the first layer

    SumLayer( 12, nHidden, input, weights1, hidden );

        // evaluate the outputs of the first layer

    ApplyNeuroFunc( nHidden, hidden, hidden );

        // evaluate the sums of the second layer

    SumLayer12( nHidden, hidden, weights2, output );

        // evaluate the outputs of the second layer

    ApplyNeuroFunc( 12, output, output );

        // get the final clock value

    clock_t t2 = clock();

        // return the elapsed amount of processor clocks

    return t2 - t1;
}
